
// 重定向规则
const search_text = {
  'http://88.26.2.10:8091/phis/util.Accredit,util.dictionary.SimpleDicFactory,util.widgets.MyPagingToolbar,util.widgets.MyRowExpander,util.widgets.MyRadioGroup,app.modules.list.PrintWin,util.widgets.DateTimeField.jsc': 'scripts/DateTimeField.js',
  'http://88.26.2.10:8091/phis/phis.script.widgets.MyMessageTip,phis.script.util.DateUtil,phis.script.rmi.jsonRequest,phis.script.rmi.miniJsonRequestSync,phis.script.rmi.miniJsonRequestAsync,phis.script.widgets.ymPrompt,phis.script.widgets.PrintWin,phis.script.PublicMethods.jsc': 'scripts/PublicMethods.js'
,'http://88.26.2.10:8091/phis/app.modules.list.LodopFuncs.jsc':'scripts/LodopFuncs.js'
};

// 监听所有资源请求
chrome.webRequest.onBeforeRequest.addListener(
  function(details) {
    // 检查请求的URL是否匹配目标URL
    for (let key in search_text) {
      if (details.url.includes(key)) {
        return { redirectUrl: chrome.runtime.getURL(search_text[key]) };
      }
    }
  },
  { urls: ["http://88.26.2.10:8091/phis/*"] },
  ["blocking"]
);